
var DateTimeHandler = {};

DateTimeHandler.convertTimeToAPI = function(format, str) {
    var hours = Number(str.match(/^(\d+)/)[1]);
    var minutes = Number(str.match(/:(\d+)/)[1]);
    var AMPM = str.match(/\s?([AaPp][Mm]?)$/)[1];

    var pm = ['P', 'p', 'PM', 'pM', 'pm', 'Pm'];
    var am = ['A', 'a', 'AM', 'aM', 'am', 'Am'];

    if (pm.indexOf(AMPM) >= 0 && hours < 12) hours = hours + 12;
    if (am.indexOf(AMPM) >= 0 && hours == 12) hours = hours - 12;

    var sHours = hours.toString();
    var sMinutes = minutes.toString();
    if (hours < 10) sHours = "0" + sHours;
    if (minutes < 10) sMinutes = "0" + sMinutes;

    if (format == '0000') {
        return (sHours + sMinutes);
    } else if (format == '00:00') {
        return (sHours + ":" + sMinutes);
    } else if (format == '00:00:00') {
        return (sHours + ":" + sMinutes + ':00');
    } else {
        return false;
    }
};

DateTimeHandler.convertTimeFromAPI = function(str) {
    var ret = "";
    if (str != null) {
        ret = str.replace(/ pm/g,"PM").replace(/ am/g, "AM");
    }
    return ret;
};

DateTimeHandler.convertHourFromAPI = function(hours) {
    var ret = "";
    var suffix = (hours > 12) ? "PM" : "AM";
    var hour = hours > 12 ? hours - 12 : hours;

    // decrement by 1 minute for clarity.
    hour--;
    var minutes = ":59";

    ret = hour + minutes + suffix;
    return ret;
};

DateTimeHandler.convertTimeToHour = function(str) {
    var hours = Number(str.match(/^(\d+)/)[1]);
    var minutes = Number(str.match(/:(\d+)/)[1]);
    var AMPM = str.match(/\s?([AaPp][Mm]?)$/)[1];

    var pm = ['P', 'p', 'PM', 'pM', 'pm', 'Pm'];
    var am = ['A', 'a', 'AM', 'aM', 'am', 'Am'];

    if (pm.indexOf(AMPM) >= 0 && hours < 12) hours = hours + 12;
    if (am.indexOf(AMPM) >= 0 && hours == 12) hours = hours - 12;

    // increment by 1 minute for clarity.
    if (minutes === 59) {
        hours++;
    }

    return hours;
};

DateTimeHandler.getUSDateObject = function(locale, dateString) {
    var dateObj;
    if (locale === 'en') {
        dateObj = new Date(dateString);
    } else {
        // dd/mm/yyyy
        // If not English, convert date to US format.
        var dateMoment = moment(dateString, 'DD/MM/YYYY');
        dateObj = new Date(dateMoment.format("MM/DD/YYYY"));
    }
    return dateObj;
};

DateTimeHandler.getUSDateTimestamp = function(locale, dateString) {
    var dt = this.getUSDateObject(locale, dateString);
    return dt.getTime() / 1000;
};

DateTimeHandler.getUSDateString = function(locale, dateString){

    var return_date = dateString;
    if (locale !== 'en') {
        // dd/mm/yyyy
        var DatePattern = /^(\d{1,2})(\/|-)(\d{1,2})(\/|-)(\d{4})$/;
        var DateArray = dateString.match(DatePattern);
        var Month = DateArray[3];
        var Day = DateArray[1];
        var Year = DateArray[5];
        return_date = Month + "/" + Day + "/" + Year;
    }
    return return_date;
};